//dojo.provide("itme.ChassisMapMRI");

// js MRI will need a task or story.  For the time being, I'm creating a function 
//  call to emulate calling into the lookup table.

//dojo.declare("itme.ChassisMapMRI", null, {

  var _TranslationTable = { 
    //Placing finder strings here as well:
    Ellipsis: "...",
    FinderInitialText: "Find a Task or Resource...",
  	ContextFinderInitialText: "Find a Task for ",    
  	ContextFinderTaskMenuFor: "Tasks for ", 
  	NoMatchesFound: "(no matches found)",   
  	Searching0: "Searching.",
  	Searching1: "Searching..",
  	Searching2: "Searching...",
  	MoreTasks: "More tasks",
  	MoreResources: "More resources",
  	FinderTaskMenu: "Tasks",
  	FinderResourceMenu: "Resources",
    Chassis: "Chassis",
    Resources: "Resources",
    FinderTooltipHelp: "Use this Inline Finder to search for all tasks or all resources currently being managed by this appliance",
    ContextFinderTooltipHelp: "Use this Inline Finder to search in context for all tasks that can be launched against the current selection",

    // CHASSIS MAP
    LEDTitle: "LED Emphasis",
    StatusTitle: "Alerts",
    NameOverlayTitle: "Labels",
    ThermalTitle: "Thermals",
    
    Bay: "Bay",
    Loading: "Loading...",
    Model: "Model",
    ModelMachineType: "Model and machine type",
    Name: "Name", 
    NameOverlayDetail: "Component Names & Properties",
    Refresh: "Page will refresh in ",
    Seconds: " seconds",
    SerialNumber: "Serial number",
    Status: "Status",
    StatusOverlayDetail: "Status Information",
    Type: "Type",
    ChassisMap: "Chassis Map",
    AccessOverlayDetail: "Hardware Access States",
    AccessTitle: "Access",
    AccessState: "Access State",
    Critical: "Critcal",
    Warnings: "Warnings",
    Informational: "Informational",
    Normal: "Normal",
    NoAccessOffline: "No Access Offline",
    NoAccessOnline: "No Access Online",
    PartialAccessOffline: "Partial Access Offline",
    PartialAccessOnline: "Partial Access Online",
    OKAccessOffline: "Full Access Offline",
    OKAccessOnline: "Full Access Online",
    UnknownAccess: "Unknown",
    NAAccess: "Not Applicable",
    PowerLED: "Power LED",
    NoData: "No Data",
    AmbientTemp: "Ambient Temperature",
    ExhaustTemp: "Exhaust Temperature Index",
    PowerIn: "Input Power",
    //AuxInPowerAvg: "Average Power In",
    PowerOut: "Output Power",
    //AuxOutPowerAvg: "Average Power Out",
    TimeLastPolled: "Last Time Metered",
    EnvButtonTooltip: "Thermal and Power Metrics",
    PowerCap: "Power Cap",
    PowerCapShort: "(Cap)",
    Healthy: "Healthy",
    Errors: "Errors",
    NoCompliancePolicy: "No compliance policy",
    NoPolicy: "No policy",
    ComplianceStatus: "Compliance Status",
    NoOSDiscovered: "No OS discovered",
    NoOSDiscoveredUpdates: "The blade's operating system needs to be discovered to apply firmware updates",
    
    // error messages
    ERROR_HWView_Title: "Hardware View Error",
    ERROR_HWView_InitialazitionFailed: "The hardware view failed to initialize, restarting your browser could resolve this issue.",
    ERROR_HWView_Unknown: "The hardware view encountered an unexpected error.",
    ERROR_HWView_DataRequestFailed: "The hardware view could not retrieve data from the director server: ",
    ERROR_HWView_PropertyDataRequestFailed: "The hardware view could not retrieve an elements properties from the director server: "
    
  };

  var defaultImagePath = "/images/hardwareView/hardware/";
  var _ImageTable = {
    // Hardware
    NormalBlade1: defaultImagePath + "itme1_194x43a.jpg",
    NormalBlade2: defaultImagePath + "obj4.jpg",
    NormalBlade3: defaultImagePath + "obj5.jpg",
    NormalBlade4: defaultImagePath + "itme1_194x43b.jpg",
    WideBlade1: defaultImagePath + "obj10.jpg",
    WideBlade2: defaultImagePath + "obj6.jgg",
    PowerUnit: defaultImagePath + "PowerModule_43x112px.png",//"PowerSupply_43x114px.png",
    ITMEUnit: defaultImagePath + "CMM_b.png",//"SmSwitch_18x165px.png",
    FanUnit1: defaultImagePath + "LargeFan.png",//"FanNew_75x69px.png",
    FanUnit2: defaultImagePath + "SmallFan_75x36px.png",//"5.jpg",
    FanControlUnit: defaultImagePath + "FanControlCard.png",//"Spacer_76x16px.png", // new
    FanFillerLarge: defaultImagePath + "LargeFanFiller.png",
    SwitchUnit: defaultImagePath + "SilverSwitch_26x343px.png",//"2.jpg",
    IOModuleUnit: defaultImagePath + "Switch_23x343px.png",//"6.jpg",
    ChassisFront: defaultImagePath + "ChassisFront_b.png", //"ChassisFront_empty.png",
    ChassisBack: defaultImagePath + "ChassisBack_b.png", //"BackChassis_empty.png",
    EmptyBladeSlot: defaultImagePath + "blank.jpg",
    TallSpacer: defaultImagePath + "LgSilverSpacer_20x343px.png", // new
    ShortSpacer: defaultImagePath + "SmallSpacer_b.png" //"SilverSp_18x176.png" // new
  };
  
  var basePath = "/images/";
  var defaultIconPath = "/images/hardwareView/";
  var accessIconsPath = defaultIconPath + "access/";
  var statusIconsPath = defaultIconPath + "status/";
  var ledIconsPath = defaultIconPath + "leds/";
  
  var _IconTable = {
  // STATUS
    StatusFilterIcon_22: statusIconsPath + "statusCluster_22.png",
    StatusFilterIcon_32: statusIconsPath + "statusFilter_32.png",
    
    StatusCritical_16: statusIconsPath + "st16_critical_24.png",
    StatusCritical_22: statusIconsPath + "st22_critical_24.png",
    StatusCritical_34: statusIconsPath + "st34critical_shad.png",
    
    StatusWarningMinor_16: statusIconsPath + "ac16_WarningMinor_24.png",
    StatusWarningMinor_22: statusIconsPath + "ac22_WarningMinor_24.png",
    StatusWarningMinor_34: statusIconsPath + "st34minorwarning_shad.png",
    
    StatusInformational_16: statusIconsPath + "st16_informational_24.png",
    StatusInformational_22: statusIconsPath + "st22_info_24.png",
    StatusInformational_32: statusIconsPath + "st32_informational.png",
    StatusInformational_34: statusIconsPath + "st34informational_shad.png",
    
    StatusNormal_16: statusIconsPath + "st16_normalSTG_24.png",
    StatusNormal_22: statusIconsPath + "st22_normalSTG_24.png",
    StatusNormal_32: statusIconsPath + "st32_normalSTG_24.png",
    
  // ACCESS STATES
    //    ACCESS_STATE_NONE_ONLINE = 100;
    AccessOnlineNone_16: accessIconsPath + "st16_normalNoAccess_24.png",
    AccessOnlineNone_22: accessIconsPath + "st22_normalNoAcess_24.png",//"status_online_noAccess_obj.gif", 
    // MISSING: AccessOnlineNone_32: defaultIconPath + "st32_normalNoAcess_24.png",
  
    //    ACCESS_STATE_NONE_OFFLINE = 101;
    AccessOfflineNone_16: accessIconsPath + "st16_offlineNoAccess_24.png",//"status_offline_noAccess_obj.gif", 
    AccessOfflineNone_22: accessIconsPath + "st22_offlineNoAccess_24.png",
    // MISSING: AccessOfflineNone_32: defaultIconPath + "st32_offlineNoAccess_24.png",
    
    //    ACCESS_STATE_PARTIAL_ONLINE = 102;
    AccessOnlinePartial_SVG: accessIconsPath + "test.svg",//statusOnlinePartialAccess.svg",
    // MISSING: AccessOnlinePartial_16: defaultIconPath + "st16_normalPartialAccess_24.png",
    AccessOnlinePartial_22: accessIconsPath + "st22_normalPartialAccess_24.png",//"statusOnlinePartialAccess_obj22.png",
    // MISSING: AccessOnlinePartial_32: defaultIconPath + "st32_normalPartialAccess_24.png",
    
    //    ACCESS_STATE_PARTIAL_OFFLINE = 103;
    AccessOfflinePartial_16: accessIconsPath + "st16_offlinePartialAccess_24.png",
    AccessOfflinePartial_22: accessIconsPath + "st22_offlinePartialAccess_24.png",
    // MISSING: AccessOfflinePartial_32: defaultIconPath + "st32_offlinePartialAccess_24.png",
    
    //    ACCESS_STATE_FULL_ONLINE = 104;
    AccessOnlineOK_16: statusIconsPath + "st16_normalSTG_24.png", // note path points to statusIconsPath.  Icon Re-Use
    AccessOnlineOK_22: statusIconsPath + "st16_normalSTG_24.png",
    AccessOnlineOK_32: statusIconsPath + "st16_normalSTG_24.png",
    
    //    ACCESS_STATE_FULL_OFFLINE = 105;
    //AccessOfflineOK_SVG: defaultIconPath + "Stopped_v1.svg",
    AccessOfflineOK_16: accessIconsPath + "st16_offline_24.png",
    AccessOfflineOK_22: accessIconsPath + "st22_offline_24.png",
    AccessOfflineOK_32: accessIconsPath + "st32_offline_24.png",
    
    //    ACCESS_STATE_UNKNOWN = 106;
    AccessUnknown_16: accessIconsPath + "st16_unknown_24.png",
    AccessUnknown_22: accessIconsPath + "st22_unknown_24.png",
    AccessUnknown_32: accessIconsPath + "st32_unknown_24.png",
    
    //    ACCESS_STATE_NOT_APPLICABLE = 107;
    AccessNotApplicable_16: accessIconsPath + "st16_undefined_24.png",
    AccessNotApplicable_22: accessIconsPath + "st22_undefined_24.png",
    AccessNotApplicable_32: accessIconsPath + "st32_undefined_24.png",
    
    
  // LED
    LEDFilterIcon_22: ledIconsPath + "LEDCluster.png",
    LEDPowerOn_22: ledIconsPath + "ac22_power_24.png",
    LEDPowerOff_22: ledIconsPath + "ac22_powerOFF_24.png",
    LEDErrorLogOn_22: ledIconsPath + "ac22_errorLog_24.png",
    LEDErrorLogOff_22: ledIconsPath + "ac22_errorLogOFF_24.png",
    LEDLocationOn_22: ledIconsPath + "ac22_location_24.png",
    LEDLocationOff_22: ledIconsPath + "ac22_locationOFF_24.png",
    LEDFaultOn_22: ledIconsPath + "ac22_enclosureFault_24.png",
    LEDFaultOff_22: ledIconsPath + "ac22_enclosureFaultOFF_24.png",
    
  // LABELS
    LabelIcon_22: defaultIconPath + "ac22_tag_24.png",
    
  // THERMALS
    //ThermalIcon_22: defaultIconPath + "ac22_thermal_24.png",
    ThermalIcon_22: defaultIconPath + "Environment_22px.png",
    
  // REFRESH
    Processing_16: basePath + "processing.gif",
    RefreshIcon_16: defaultIconPath + "ac16_refresh.png",
    RefreshIcon_22: defaultIconPath + "ac22_refresh_24.png",
    
  // COMPLIANCE & OS
    ComplianceIcon_22: defaultIconPath + "ac22_compliance_24.png",
    
  // OTHER
    Seperator_18: basePath + "Separator.png"
  };

  function Translate(StringId) {
    return _TranslationTable[StringId];
  }
  
  function getImage(ImageId) {
    //CMTrace("MAIN", "getImage("+ImageId+"): " + contextPath + _ImageTable[ImageId]);
    return contextPath + _ImageTable[ImageId];
  }
  
  function buildIconImageTag(IconId, styleClass, size) {
    var hasSVG = false;
    var imgTag = "";

    // find an icon of == or larger size     
    for (var i = size; i < 40; i++) {
      if ( _IconTable[IconId+"_"+i]) { 
        imgTag = "<img src='"+contextPath+_IconTable[IconId+"_"+i]+"' width='"+parseInt(size)+"px' height='"+parseInt(size)+"px' class='"+styleClass+"'>";
        break;
      }
    }
    if (imgTag == "") // no images >= , then search <
    {
      for (i = size; i > 12; i--) {
        if ( _IconTable[IconId+"_"+i]) { 
          imgTag = "<img src='"+contextPath+_IconTable[IconId+"_"+i]+"' width='"+parseInt(size)+"px' height='"+parseInt(size)+"px' class='"+styleClass+"'>";
          break;
        }
      }
    }
    
    // if we have an SVG wrapper the img tag with it.  Browsers will render the Object tag first if it can
    if (false) {//_IconTable[IconId+"_SVG"]) {  
      imgTag = "<object type='image/svg+xml' data='"+contextPath+_IconTable[IconId+"_SVG"]+"' width='"+parseInt(size)+"' height='"+parseInt(size)+"' >" 
               + imgTag
               + "</object>";
    } 
      
    //CMTrace("MAIN", "buildIconImageTag("+IconId+","+styleClass+","+size+"): " +imgTag);  
    
    return imgTag;
  }
  
  // return the path to the icon id given.  If no _xx size is given in the id or 'size' parm doesn't match, largest match is returned
  function iconPath(IconId, size) {
    if ( _IconTable[IconId] )
      return contextPath + _IconTable[IconId];
    if ( size )
      if ( _IconTable[IconId+"_"+size] )
        return contextPath + _IconTable[IconId+"_"+size];

    // iconID was no a direct match & size was not given or didn't match
    
    // then... find largest match     
    for (var i = 40; i > 14; i-=2) {
      if ( _IconTable[IconId+"_"+i]) { 
        return contextPath + _IconTable[IconId+"_"+i];
      }
    }
    return "";
  }
  
  function buildImageString(ImageId, propsString, constraint) {
    
  }
//});
