/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.navmodel.Exception"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.navmodel.Exception"] = true;
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * �Restricted Materials of IBM�
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.navmodel.Exception"); 
 
////////////////////////////////////
// Exception
////////////////////////////////////  
dojo.declare("ibm.tivoli.navmodel.Exception", null, {
	// private members
	_version: null,
	_exception: null,
	
	/*=====
	constructor_kwArgs: function(version, exception) {
		// version: Float
		//		version used to communicate with rest service
		// exception: Object
		//		json exception object
	},
	=====*/

	 constructor: function(/*constructor_kwArgs*/ kwArgs) {
		// summary
		//		Constructs Exception object.
		this._version = kwArgs.version;
		this._exception = kwArgs.exception;		
	},

	getMsgId: function() {
		return this._exception.msgId;
	},
	
	getMsgSeverity: function() {
		return this._exception.msgSeverity;
	},
	
	getMsgText: function() {
		return this._exception.msgText;
	}
});

}
