/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.charts.dijit.ChartPanelPageHeader"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.charts.dijit.ChartPanelPageHeader"] = true;
dojo.provide("ibm.tivoli.tip.charts.dijit.ChartPanelPageHeader");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartPanelPageHeader",[dijit._Widget,dijit._Templated],{	
	
	templateString:"<div>\n<div>\n    <div class=\"tiv-chart-page-header-title\" dojoAttachPoint=\"titleDiv\"><span dojoAttachPoint=\"titleArea\"></span></div>    \n    <div class=\"tiv-chart-page-header-description\" dojoAttachPoint=\"descDiv\"><span dojoAttachPoint=\"descArea\"></span></div>\n</div>\n</div>\n",
	
	postCreate: function (){
		this.inherited(arguments);
		this.titleArea.innerHTML = this.title;
		this.descArea.innerHTML = this.desc;
	},
	
	resize: function (size){	
		dojo.style (this.titleArea, {
				"width": size.w				
		});
		dojo.style (this.descArea, {
				"width": size.w				
		});
	}

});

}
