/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.charts.dijit.LabelSelector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.charts.dijit.LabelSelector"] = true;
dojo.provide("ibm.tivoli.tip.charts.dijit.LabelSelector");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.form.Button");

dojo.declare("ibm.tivoli.tip.charts.dijit.LabelSelector",[dijit._Widget,dijit._Templated],{

	widgetsInTemplate: true,
	templateString:"<div>\n<table style=\"margin: 0; padding: 0; border:0; width:100%; background-color:inherit; background-image:inherit;\" cellpadding=\"0\" cellspacing=\"0\">  \n\t<tr style=\"vertical-align:middle;\">\n\t\t<td style=\"padding: 0px; border:0px; width:70%;\">\n\t\t\t<div dojoAttachPoint=\"labelBoxDiv\"></div>\n\t\t</td>\n\t\t<td style=\"padding: 0px; border:0px; width:10%;\"><div></div></td>\n\t\t<td style=\"padding: 0px; border:0px; width:10%;\" align=\"right\">\n\t\t\t<button dojoType=\"dijit.form.Button\" dojoAttachPoint=\"addRowButton\" dojoAttachEvent=\"onClick:addRow\" width=\"100%\">+</button>\t\n\t\t</td>\n\t\t<td style=\"padding: 0px; border:0px; width:10%;\">\t\n\t\t\t<button dojoType=\"dijit.form.Button\" dojoAttachPoint=\"delRowButton\" dojoAttachEvent=\"onClick:removeRow\" width=\"100%\">-</button>\n\t\t</td>\n\t</tr>\n</table>\n</div>\n",
	SEARCH_ATTR: "label",
	dataStore: null,	
	rowIndex: 0,
	currentValue: null,
	
	constructor: function(){		
		this.dataStore = null;	
		this.currentValue = null;
	},		
	
	addRow: function(event){		
		event.rowIndex = this.rowIndex;		
	},
	
	removeRow: function(event){		
		event.rowIndex = this.rowIndex;		
	},
	
	postCreate: function(){					
		this.labelBox = new dijit.form.FilteringSelect({
			store: this.dataStore,
			searchAttr: this.SEARCH_ATTR, 
			value:  this.currentValue}, 
			this.labelBoxDiv
		);		
		this.labelBox.connect(this.labelBox, 'onClick', function(){
			dojox.grid.util.comboOpened = !this._opened;			
		});
		dojo.style(this.labelBox.domNode, {"width":"95%"});				
	}	
});

}
