/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.charts.dijit.ParametersPage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.charts.dijit.ParametersPage"] = true;
dojo.provide("ibm.tivoli.tip.charts.dijit.ParametersPage");

dojo.require("ibm.tivoli.tip.charts.dijit.ChartPanelSummaryPage");
dojo.require("ibm.tivoli.widgetbuilder.requiredparameters.RequiredParameters");

dojo.declare("ibm.tivoli.tip.charts.dijit.ParametersPage",[ibm.tivoli.tip.charts.dijit.ChartPanelSummaryPage],{
	
	constructor: function(){
		this.inherited(arguments);
		this.contentTitle = this.resources_.PARAMETER_CONTENT_TITLE;
		this.contentDesc = this.resources_.PARAMETER_CONTENT_DESC;	
		this.pageId = "1st_params"
	},	
	
	OnPageSelected: function(){	
		this.inherited(arguments);	
		if(!this.widgetDefCont){
			this.widgetDefCont = new ibm.tivoli.widgetbuilder.requiredparameters.RequiredParameters({	
				width: this.operateAreaSize.w +"px",
				height: this.operateAreaSize.h +"px",
				wizard: this.wizard,		
				widgetDefinition: this.widgetDef
			}, this.operateDiv);
			this.widgetDefCont.startup();			
			this.widgetDefCont.subscribe(dojo.hitch(this, this.onChange));	
		}else{
			this._setWidgetDefUponDatasetChange();
		}
	},
	
	getWidgetDefinition: function(){
		this.widgetDef = this.widgetDefCont.getWidgetDefinition();		
		return this.widgetDef;
	},
	
	resize: function(size){		
		if(this._triggerResize(size)){		
			this.inherited(arguments);
			this.operateAreaSize = {
				w: (this._pageSize.w-5-10)*0.6-5,
				h: this._pageSize.h-5-dojo.coords(this.titleArea.domNode).h
			};
			this.operateArea.domNode.style.width = "60%";
			this.sumContainer.domNode.style.width = "40%";
			if ( this.widgetDefCont ) {
				this.widgetDefCont.resize(this.operateAreaSize);
			}		
		}
	}

});

}
