/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.charts.dojo.ChartCMSMenuProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.charts.dojo.ChartCMSMenuProvider"] = true;
dojo.provide("ibm.tivoli.tip.charts.dojo.ChartCMSMenuProvider");

dojo.require("ibm.tivoli.tip.dijit.CMSMenuProvider");

dojo.declare("ibm.tivoli.tip.charts.dojo.ChartCMSMenuProvider", ibm.tivoli.tip.dijit.CMSMenuProvider, {  
	getMenuCommand: function (commandName, context, menuItem) {      
		this._context = context;
		this.inherited(arguments);
	},
	sendEvent: function (data) {   
		if(!data.parameters){
			data.parameters = [];
		}
		for(var i=0;i<this._context.selectedData.columns.length;i++){
			if(this._context.selectedData.columns[i].name){
				data.parameters.push({
					name: this._context.selectedData.columns[i].name,
					value: this._context.selectedData.rows[this._context.selectedData.columns[i].field]
				});	
			}		
		}
		this.inherited(arguments);
	}
});

}
