/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.navwidget.iwidget.NodeClickedOnEvent"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.navwidget.iwidget.NodeClickedOnEvent"] = true;
dojo.provide("ibm.tivoli.tip.navwidget.iwidget.NodeClickedOnEvent");

dojo.require("ibm.tivoli.tip.navwidget.iwidget.Event");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Resource");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Trace");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.NodeClickedOnEvent",[ibm.tivoli.tip.navwidget.iwidget.Event],{
	constructor: function constructor(args){
		new ibm.tivoli.tip.navwidget.iwidget.Trace(this,["addItems","_addItem"]);
		if(!args){
			this._createNewEvent("http://ibm.com/tip#NodeClickedOn");
		} else if(typeof args === 'string'){
			this._createNewEvent(args);
		} else {
			this._populateExistingEvent(args);
		}
	},
	addItems: function addItems(items){
		if(items){
			if (dojo.isArray(items)) {
			    dojo.forEach(items,dojo.hitch(this,this._addItem));
			}else{
				this._addItem(items);
			}
		}
	},
	_addItem: function _addItem(item){
		var resource=new ibm.tivoli.tip.navwidget.iwidget.Resource(item);
		this._addResource(resource);
	}
});

}
