/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView"] = true;
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * �Restricted Materials of IBM�
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide ("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView");

dojo.require("ibm.tivoli.navmodel.DatasetItemsStore");

dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer");
dojo.require ("ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.NavModelTable");

dojo.requireLocalization("ibm.tivoli.tip.navwidget", "resources", null, "ROOT,ar,cs,da,de,es,fi,fr,he,hr,hu,it,ja,ko,nb,nl,pl,pt-br,ru,sl,sv,tr,zh-cn,zh-tw");

ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView");

dojo.declare ("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView",
	ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView,
	{
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	//***************************
	// "Private"
	//***************************
	
	// _trace: [private] Trace
	//		Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView._trace,
	
	constructor: function () {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		//this._global = ibm.tivoli.tip.dojo.Global.setSingleton( "123", " ");
		this.title = this.commonResources.RESOURCE_VIEW;
		this.labelIconClass = "resourceViewIcon";
	    this._pDEFAULT_WIDGET_DEF_INFO = {
			className: "ibm.tivoli.navmodel.TableWidgetDef",
			baseUrl: "/ibm/tivoli/rest",
	    	provider: "any",
	    	datasource: "any",
	    	widget: "table",
	    	definition: "DefaultItemsTable"
		},
		
		this._pTableType = "item";
		this._pTableClassName = "ibm.tivoli.tip.navwidget.table.dijit.NavModelTable";

	},

	
	_createTableStore: function(columnIds){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// columnIds:
		//		
		
		// create or update store
		if(!this._dataStore && this.dataset) {
			this._dataStore = new ibm.tivoli.navmodel.DatasetItemsStore({dataset:this.dataset, defaultProperties:columnIds, returnItem:true});
			this.inherited(arguments);
		}
	}	
	
});

}
