/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


var finder;
var contextFinder;
function tmpLoadFinderRequires() {   
	itmeUtils.initializeTimer("finderAllTimer");       
  itmeUtils.traceTimeDelta("finderAllTimer", "finder init", true); 	
    
  dojo.require("itme.finder.Finder");  
}

function delayRequires() { 	
	dojo.require("ibm.tivoli.navmodel.Dataset");  
	contextFinder.initializeTaskCache();	
}

function createFinder(FinderParentDOMNodeID, finderDomElement) {
    // the tundra class is necessary for the tooltip pointer to function.  There may be other ways to accomplish this if necessary.
    	
    dojo.addClass(document.body, "tundra");   // tundra class hack    
  	delete Object.prototype.toJSONString;
    if(finder) {
    	finder.initializeFieldReferences(FinderParentDOMNodeID, finderDomElement);
    	itmeUtils.traceTimeDelta("finderAllTimer", "finder init cache", true); 	
    	finder.initializeDataStores(FinderParentDOMNodeID);
    	itmeUtils.traceTimeDelta("finderAllTimer", "finder end cache", true); 	
    	return;
    }
    finder = new itme.finder.Finder(FinderParentDOMNodeID, finderDomElement); 
    itmeUtils.traceTimeDelta("finderAllTimer", "finder finish", true); 	
}
function createContextFinder(FinderParentDOMNodeID, finderDomElement) {
    phxTrace("contextFinder - createFinder, finderDomElement: " + finderDomElement);
    // the tundra class is necessary for the tooltip pointer to function.  There may be other ways to accomplish this if necessary.
    dojo.addClass(document.body, "tundra");   // tundra class hack    
  	//delete Object.prototype.toJSONString;
    
    //if(contextFinder) {
   // 	contextFinder.initializeFieldReferences(FinderParentDOMNodeID, finderDomElement);
    //	return;
   // }
    contextFinder = new itme.finder.Finder(FinderParentDOMNodeID, finderDomElement); 
    setTimeout('delayRequires()', 20);

}

function isChassisMapRendered() {
	if(dojo.byId('TheChassisMapIsRendered')) {
		return true;
	}
	return false;
}
function objHighlightSearchStr(targEl, searchStr, targetStr, isCategory) {
	targEl.innerHTML = "";
  var type = "span"; var textClass = "";
  if(isCategory) {
  	type = "h1";
  	textClass = "categorySectionTitle";
  }
  var resultEl = dojo.create(type, {className: textClass}, targEl);  

 				
  var re = new RegExp(searchStr, "i");  
  var startPos = targetStr.search(re); 
   
  //if no match just return the string as-is 
  if (startPos <= -1){
    dojo.create("span", {innerHTML:targetStr}, resultEl);
    return resultEl;    
  } 

  var s0 = dojo.create("span", {innerHTML:targetStr.substring(0, startPos)}, resultEl);
  var s1 = dojo.create("span", {innerHTML:targetStr.substring(startPos, startPos + searchStr.length)}, resultEl);
  dojo.addClass(s1, "SearchSubstringHighlight");  
  dojo.create("span", {innerHTML:targetStr.substring(startPos + searchStr.length, targetStr.length)}, resultEl);
  return resultEl;
  
}
