/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["itme.itmeUtils"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["itme.itmeUtils"] = true;
//dojo.provide("itme.itmeUtils");

// TODO:
// 1. Clean code
//  a. Seperate out Overlays and Selection behaviors from Chassis Map
//  b. super / sub class the overlays

// GLOBAL (Non Scoped) =============================    
  TRACE_INFO= [];
  TRACE_INFO.LAYOUT = false;
  TRACE_INFO.OVERLAY = false;
  TRACE_INFO.SELECTION = false;
  TRACE_INFO.MAIN = true;
  TRACE_INFO.CA_MENU = false;
  
  FSMFlightRecorder = {
    curSize: 0,
    startIndex: 0,
    entries: [],
    maxSize: 75,
    add: function (traceEntry) {
      var now = new Date();
      var timeString = now.getFullYear() + "/" + now.getMonth()+1 + "/" + now.getDate() + " " + 
                       now.getHours() + ":" + now.getMinutes()+":"+now.getSeconds() + "." + now.getMilliseconds();
      //var timeString = now.format("yyyy/mm/dd HH:MM:ss.l");
      if ( this.curSize < this.maxSize ){
        this.entries[this.curSize] = timeString + " - " + traceEntry;
        this.curSize++;
      } else {
        this.entries[this.startIndex] = timeString + " - " + traceEntry;
        this.startIndex += 1;
        if ( this.startIndex >= this.maxSize)
          this.startIndex = 0;
      }
    },
    test: function () {
      var i;
      try {
        console.info("DEBUG -- BEGIN -- TEST FLIGHT RECORDER DATA");
        for (i = 0; i < this.curSize; i++)
        {
          if ( this.startIndex + i >= this.curSize)
            console.info(this.entries[this.startIndex + i - this.curSize])
          else
            console.info(this.entries[this.startIndex + i])
        }
        console.info("DEBUG -- END -- TEST FLIGHT RECORDER DATA");
      } catch(e) { }
    },
    
    toString: function (newLine) {
      if (newLine == "undefined")
        newLine = "<br>"
      var i;
      var outputString = "";
      try {
        outputString = outputString + " -- BEGIN -- FSM SCRIPT FLIGHT RECORDER DATA (time values are from the browsers system)" + newLine;
        for (i = 0; i < this.curSize; i++)
        {
          if ( (this.startIndex) + i >= this.curSize)
            outputString = outputString + this.entries[this.startIndex + i - this.curSize]+ newLine;
          else
            outputString = outputString + this.entries[this.startIndex + i]+ newLine;
        }
        outputString = outputString + " -- END -- FSM SCRIPT FLIGHT RECORDER DATA";
      } catch(e) { }
      return outputString;
    }
  
  }
  
//Work in progress, this Javascript below hides the left nav area automatically, but still has bugs
function hideNavigatorNavTree()
{
  var toggleImage = parent.navigation.document.getElementById("NavTreeToggleImage");
  var toggleLink = parent.navigation.document.getElementById("toggleLink");

  if(toggleImage.src.indexOf('/ibm/console/images/isclite/navigation_close.gif') != -1) {
    toggleLink.onclick();
// var navtree = parent.navigation.document.getElementById("NavTree");
// var navicontent = parent.document.getElementById("navi-content");
// var isBidi = 'no';
// navtree.style.visibility = "hidden";
// navtree.style.width="1";
// navtree.style.height="1";
// navtree.style.overflow="hidden";

 //parent.navigation.document.body.scroll="no";
// navicontent.cols="16,*";
 //toggleImage.src= '/ibm/console/images/isclite/navigation_open.gif';
 //toggleImage.title ='Show Navigation';
 //toggleImage.alt = 'Show Navigation';
 //var navtreetoggle = parent.navigation.document.getElementById("NavTreeToggleDiv");
 //navtreetoggle.style.top = document.body.scrollTop +(document.body.clientHeight/2)+"px";
  } 
}
// Temporary.  The intent is that this should be in the jsp (here for speed of development keeping it out of the jsp)
function testIfHardwareViewIsRendering(viewId) {
  //setTimeout('validateViewIsRenderingProperly()', 10000);
}
/*
function validateViewIsRenderingProperly() {
  // If the hardware view page is shown, but the hardware view failed to render (Firefox bug???)
  if (dojo.byId("ChassisMap")) { 
    if ( ! dojo.byId("hardwareViewLoadingText")) {
      // ERROR ERROR ERROR ERROR
      itmeUtils.CMTrace("MAIN", "HARDWARE VIEW SCRIPTS FAILED TO LAUNCH - RESTART BROWSER");
      alert("HARDWARE VIEW SCRIPTS FAILED TO LAUNCH - RESTART BROWSER");
    }
    itmeUtils.CMTrace("MAIN", "hardware view elements found, everything initialized ok");
      processRefresh("tableView");
      setTimeout('processRefresh("tableView_cmerror"+Translate("ERROR_HWView_InitialazitionFailed"))', 4000);
  }
  else
    itmeUtils.CMTrace("MAIN", "hardware view elements not found, not rendering hardware view");
}*/
 
function tmpLoadRequires(){
  //phxTrace("dojo base URL: " + dojo.baseUrl);
  phxTrace("LOCATION - HREF: " + location.href);
  phxTrace("LOCATION - PATHNAME: " + location.pathname);
  
    
    //setTimeout('tempLoadChassisMapRequires()', 20); //Still debugging this to make sure it won't break chassis map
}
/*function tempLoadChassisMapRequires() {
    dojo.require("itme.ChassisMap");
}*/

var chassisMap;
// Temporary.  The intent is that this should be in the jsp (here for speed of development keeping it out of the jsp)
function tmpMakeItSo(ChassisMapParentDOMNodeID, nodeIdToGetSizeFrom, chassisId, selectedElementsByItemId){
    phxTrace("tmpMakeItSo - ChassisId: " + chassisId);
    
    //phxTrace("LOCATION - HREF: " + location.href);
    
    // the tundra class is necessary for the tooltip pointer to function.  There may be other ways to accomplish this if necessary.
    //dojo.addClass(document.body, "soria");   // tundra class hack
    dojo.addOnUnload(chassisMapPageUnload);
    //dojo.addOnWindowUnload(testWindowUnload);
    
    phxTrace("chassisMap?: " + chassisMap);
    if ( chassisMap == null )
    { chassisMap = new itme.ChassisMap.ChassisMap({}, 
                                     ChassisMapParentDOMNodeID, 
                                     //"GROUP:GroupID_1275925181492",  // dir2go local
                                     "CHASSIS_MAP_COLLECTION",
                                     chassisId);                    // collection
      chassisMap.setSelection(selectedElementsByItemId);                              
      if (nodeIdToGetSizeFrom )
        chassisMap.setDimensionsBasedOnNode(dojo.byId(nodeIdToGetSizeFrom));
      chassisMap.renderMap();
    }
    else
      phxWarn("Chassis map already rendered, NOT going to re-render");
}

function phxTrace(strOutput)
{
  FSMFlightRecorder.add(strOutput);
  try {
    console.info(strOutput);
  } catch(e) { }
}

function phxWarn(strOutput)
{
  FSMFlightRecorder.add("WARNING - " + strOutput);
  try {
    console.warn(strOutput);
  } catch(e) { }
}

function phxError(strOutput)
{
  FSMFlightRecorder.add("!ERROR! - " + strOutput);
  try {
    console.error(strOutput);
  } catch(e) { }
}

function cleanUpChassisMap()
{
  phxTrace("cleanUpChassisMap");
  if ( typeof(chassisMap) != "undefined" && (chassisMap != null)) // when table view is loaded, clean up 
    chassisMap.cleanUp();
  chassisMap = null;
}

function chassisMapPageUnload()
{ 
  phxTrace("page unload, cleaning up chassis map");
  // call the code that sets up a refresh
  cleanUpChassisMap(); 
  //dojo.cookie("chasisMap.currentOverlay", null, {expires: -1});
}

//function testWindowUnload() {
//  phxTrace("TEST - window unload");
//}

var itmeUtils = {
    
  // Used to decouple some 'requires' calls from the jsp for faster development.  Once calls are finalized, may as well 
  // move to jsp
  externalLoadRequires: function() {
    
  },
  
  getStorageElementActions: function() {
    if (chassisMap) {
      var storageElement = chassisMap._selectedStorageElement;
      if (storageElement) {
        var host = window.location.host;
        var propsURL = "https://"+host+"/ibm/console/xLaunch.do?pageID=com.ibm.usmi.console.resnav.navigationElement&hint=PROPERTIES&sourceToken="+storageElement.OID;
        var scURL = "https://"+host+"/ibm/console/xLaunch.do?pageID=com.ibm.director.console.storage.navigation.Storage2ServerMappingView.navElem&sourceToken="+storageElement.OID;
        var scuHTML;
        scuHTML = "<span class=\"actionsHeadingText\">Common Actions for: "+storageElement.OID+","+storageElement.TYPE+"</span>"
        scuHTML =  scuHTML + "<table cellpadding=\"1\" border=\"0\"><tbody>"
        scuHTML =  scuHTML + "<tr><td></td></tr>";
        // properties
        scuHTML =  scuHTML + "<tr><td><span class=\"categoryActionLink\">General</span></td></tr>";
        scuHTML =  scuHTML + "<tr><td><a href=\""+propsURL+"\" class=\"actionLink target=\"_parent\">Properties</a></td></tr>";
        // storwize
        scuHTML =  scuHTML + "<tr><td><span class=\"categoryActionLink\">Remote Access</span></td></tr>";
        scuHTML =  scuHTML + "<tr><td><a href=\""+storageElement.clusterURL+"\" class=\"actionLink\" target=\"_blank\">Launch IBM Flex System V7000</a></td></tr>";
        // storage control
        scuHTML =  scuHTML + "<tr><td><span class=\"categoryActionLink\">Storage Control</span></td></tr>";
        scuHTML =  scuHTML + "<tr><td><a href=\""+scURL+"\" class=\"actionLink\" target=\"_parent\">Storage to Server Mapping View</a></td></tr>";
        scuHTML =  scuHTML + "</tbody></table>";

        return scuHTML;
      }
    } 

    return null;
  },

  CMTrace: function (codePath, outputText) {
    if (TRACE_INFO[codePath] === false) // if the codepath is part of the array, and true 
      return;
    if (!TRACE_INFO[codePath])
      phxTrace(outputText);
    else if (TRACE_INFO[codePath] === true)
      phxTrace(codePath + " - " + outputText);
  },
  CMWarn: function (codePath, outputText) {
    phxWarn(codePath + " - " + outputText);
  },
  CMError: function (codePath, outputText) {
    phxError(codePath + " - " + outputText);
  },
  

  _myTimers: [],
  initializeTimer: function (timerName) { 
    this._myTimers[timerName] = new Date(); 
  },

    
  // make a page element visible
  showPageElement: function(elName) {
    var tbl = document.getElementById(elName);
    tbl.style.display = 'block'; // consider if using for text elements "inline"
  },

  // hide a page element
  hidePageElement: function (elName) {
    var tbl = document.getElementById(elName);
    tbl.style.display = 'none';
  },
    
  traceTimeDelta: function (timerName, deltaMessage, bRestartTimer) {
    if (this._myTimers[timerName]) {
      var now = new Date();
      phxTrace(deltaMessage + " : " + (now - this._myTimers[timerName]) + "ms");
    }
    if (bRestartTimer === true)
      this._myTimers[timerName] = new Date();
  },
    
  getProperty: function (item, propertyName) {
    var propValue = null;
    try {
      var prop = item.getProperty(propertyName);
      if (prop) {
        propValue = prop.getValue();
      }
    } 
    catch (err) {
      phxTrace("an error occurred getting properties for " + item.getLabel() + " : " + err);
    }
    return propValue;
  },
    
  isChrome: function () {
    return (navigator.userAgent.toLowerCase().indexOf('chrome') > -1);
  },
    
  // creates and returns the element
  /* parmameters:
   * elementType: html element type "span", "div", etc.. (DEFAULT: DIV)
   * styleClass: "one or more style classes seperated by a space"
   * style: object containing html style info.  Used as dojo.attr(<>,"Style",style)
   * parentNode: append this element to...
   * baseDimensionsOnNode: set default dimensions based on node...:
   * innerHTML: a string that will be put within the elements opening and closing tags
   */
  createElement: function(elementId, parentNode, parms) {
    var newElement;
    if (!parms) parms = {};
    var elementType = (parms.elementType) ? parms.elementType : "div";
    
    if (dojo.byId(elementId)) 
      return dojo.byId(elementId);
  
    try {
      newElement = document.createElement(elementType);
      dojo.attr(newElement, "id", elementId);
      if ( parms.styleClass )
        dojo.attr(newElement, "class", parms.styleClass);
      if ( parms.style )
      dojo.attr(newElement, "style", parms.style);

      // IE hack, we have to clone the node and do future work from the clone
      if ( parentNode )
        parentNode.appendChild(newElement.cloneNode(true));
      else
        newElement.cloneNode(true);
      newElement = dojo.byId(elementId);
    } 
    catch (e) {
      phxTrace("error appending new element ("+elementId+"):" + e.message);
    }
    
    if ( parms.baseDimensionsOnNode && newElement ) {
      var sizeToElementCBox = dojo.contentBox(parms.baseDimensionsOnNode);
      dojo.contentBox(newElement, {
        w: sizeToElementCBox.w,
        h: sizeToElementCBox.h
      });
    }
    
    if ( parms.innerHTML )
      newElement.innerHTML = parms.innerHTML;
    
    return newElement;
  },
    
  myJoin: function (theArray, seperator) {
    if (!seperator)
      seperator = ",";
    var first = true;
    var retString = "";
    for (var elementIndex in theArray) {
      if (first === false)
        retString += seperator;
      retString += theArray[elementIndex];
      first = false;
    }
    return retString;
  },
    
  associativeArrayLength: function (theArray) {
    var size = 0;
    for (elementIndex in theArray) 
      size++;
    return size;
  },
    
  //nice way to attach events with params; from http://stackoverflow.com/questions/95731/why-does-an-onclick-property-set-with-setattribute-fail-to-work-in-ie
  makeEvent1Param: function (element, callback, param1, event)
  {
    function local(e) {
        return callback(param1, e);
    }

    if (element.addEventListener) {
        //Mozilla
        element.addEventListener(event,local,false);
    } else if (element.attachEvent) {
        //IE
        element.attachEvent("on"+event,local);
    }
  },
    
  // returns true if control or shift was pressed during the mouseEvent
  isMultiSelectKeyUsed: function(mouseEvent)  {
    //this.CMTrace("SELECTION", "Event test: e.ctrl " + mouseEvent.ctrlKey);
    //this.CMTrace("SELECTION", "Event test: e.shift " + mouseEvent.shiftKey);
    if ( mouseEvent.ctrlKey == true || mouseEvent.shiftKey == true)
      return true;
    return false;
  },
  
  /*
   * Will create a new span element as a child of 'element' parameter containing 'text' ellipsed if necessary
   * parms { // all optional parms
   *  styleClass: will append this style to the new span element
   *  ellipseAt: int index to insert the ellipse at, use for inserting an ellipse at a point within the 'text'
   *  ellipseAfter: string to insert ellipse after, use to insert ellipse at a point within the 'text'
   *  returnOnly: true if we just want the string
   *  }
   */
  insertEllipsedTextSpanIntoElement: function(element, text, parms)
  {
    if ( !parms )
      var parms = {};
    var elementCount = 0;
    var elementId = element.id+"_txtSpan"+elementCount;
    while ( dojo.byId(elementId) ) {
      elementCount++;
      elementId = element.id+"_txtSpan"+elementCount;
    }
  
    var txtSpan = this.createElement(element.id+"_txtSpan", 
                                     element,
                                      {elementType: "span",
                                       styleClass: parms.styleClass,
                                       innerHTML: text});
  
    var width = dojo.contentBox(element).w;

    var wi = dojo.contentBox(txtSpan).w; 
    if(wi > width)
    {
      var i = 1;
      txtSpan.innerHTML = '';
      wi = dojo.contentBox(txtSpan).w;
      while(wi < (width) && i < text.length)
      {
        txtSpan.innerHTML = text.substr(0,i) + '...';
        i++; 
        wi = dojo.contentBox(txtSpan).w;
      } 
      
      if ( parms.insertAfter ) 
        parms.insertAt = text.indexOf(parms.insertAfter) + parms.insertAfter.length;
      if ( parms.insertAt )
        txtSpan.innerHTML = text.substr(0, parms.insertAt) + "..." + text.substr(parms.insertAt, i-2) ;
      else
        txtSpan.innerHTML = text.substr(0,(i-2)) + '...'; // 1 less than what sent us over the size limit
    }
    
    if ( parms.returnOnly ) {
      var returnStr = txtSpan.innerHTML;
      dojo.destroy(txtSpan);
      return returnStr;
    }
  },

  splitFRMDividedProperty: function (item, propName) {
    var dataArray = [];
    var property = this.getProperty(item, propName);
    if ( property ) {
      this.CMTrace("OVERLAY", propName + ": " + property);
      var propList = property.split("-,-");
      for (i = 0; i <  propList.length; i++) {
        if ( propList[i] != "")
        {
          this.CMTrace("OVERLAY", "Property : " + propList[i]);
          keyValuePair = propList[i].split("=");
          if ( keyValuePair[1] )
            dataArray[keyValuePair[0]] = keyValuePair[1];
        }
      }
    }
    else
      this.CMTrace("OVERLAY", propName + ": was empty or not passed");
    
    return dataArray; 
  }
};

}
