dojo.provide("itme.finder.GroupDataStore");

dojo.require("itme.finder.FinderBaseDataStore");

dojo.declare("itme.finder.GroupDataStore", [itme.finder.FinderBaseDataStore], {
   constructor: function(type, domId){  	
    	this.populateItems(dojo.byId(domId + ':groupFinderData').innerHTML);
    },
    populateItems: function() {
    	this.inherited(arguments);    
    },      
	
    
	initiateTaskSearch: function(searchString, finderObj) {	
		query = "name:'*" + searchString + "*' OR category:'*" + searchString + "*'";			
		itmeUtils.traceTimeDelta("finderTimer", "before initiating search", true); 
  		if(this._dataStore) {
  			var request = this._dataStore.fetch({
				query:{
					complexQuery: query
				}, queryOptions: {
					ignoreCase: true
				}, 
 				onError: dojo.hitch(finderObj, finderObj.fetchFailed), 
 				onComplete: dojo.hitch(finderObj, finderObj.doGroupSearch)
 			});	
  		} else {
  			finderObj.doGroupSearch(new Array(0), null);
  		}
			
	}
});
	