#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#!/bin/bash
PLATFORM_XML_FILE=/opt/ibm/director/lwi/conf/org.eclipse.update/platform.xml
PLATFORM_XML_BACKUP_FILE=/opt/ibm/director/lwi/conf/org.eclipse.update/.platform.xml.backup
if [ -f $PLATFORM_XML_BACKUP_FILE ]; then		
	mv $PLATFORM_XML_BACKUP_FILE $PLATFORM_XML_FILE
fi  
AMINFO_FILE=/opt/ibm/director/vmi/data/AMInfo.config
AMINFO_LOCATION=/tmp/AMInfo.config
if [ -f $AMINFO_FILE ]; then		
	mv $AMINFO_FILE $AMINFO_LOCATION
fi  

if [ `grep -c "setupwizard.force\" ovfenv:value=\"no\"" /opt/ibm/ae/AP/ovf-env.xml` == 1 ]; then
sed -i 's/setupwizard.force\" ovfenv:value=\"no\"/setupwizard.force\" ovfenv:value=\"yes\"/' /opt/ibm/ae/AP/ovf-env.xml
touch /opt/ibm/director/vmi/data/.licenseaccepted
touch /opt/ibm/director/vmi/data/.wizardcompleted
/opt/ibm/director/vmi/bin/launchlap.sh
/opt/ibm/director/vmi/bin/stoplap.sh
/opt/ibm/director/vmi/bin/fsmPostLwiUpdatePatches.sh
exit 0
fi

#Call slpRegs.sh to register slp services
FILE=/opt/ibm/director/vmi/data/reboot.out
#If a reboot occurs, run slpRegs.sh. Otherwise, create flag file. 
if [ -f $FILE ]; then 
   bash /opt/ibm/director/vmi/bin/slpRegs.sh &
else
   date=$(date)
   echo ""$date" Created from checkLAOption.sh: Flag file for first time boot up." > $FILE 
fi

FOUNDATIONS_FILE=/opt/ibm/director/vmi/data/.foundationsReset
if [ -f $FOUNDATIONS_FILE ]; then 
#do processing once, delete flag file
#   rm $FOUNDATIONS_FILE
#do other processing

fi

exit 0