#!/bin/sh
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

if [ $# -eq 2 ]; then
User=$1
Password=$2
else
echo "Usage: provide the following 2 parameters separated by spaces: userid password"
exit 1
fi
echo 'begin' >> /tmp/networkadvisorConfig.out
/opt/networkadvisor/bin/silentInstall >> /tmp/networkadvisorConfig.out 2>&1	
cd /opt/networkadvisor/bin/
./useraccount -add $User $Password >> /tmp/networkadvisorConfig.out 2>&1
./useraccount -delete Administrator >> /tmp/networkadvisorConfig.out 2>&1
./dbpasswd dcmadmin passw0rd $Password $Password >> /tmp/networkadvisorConfig.out 2>&1
/opt/ibm/director/itme/apps/networkadvisor/stopServer >> /tmp/networkadvisorConfig.out 2>&1
echo 'end' >> /tmp/networkadvisorConfig.out
exit 0
