dojo.provide("itme.ChassisMap.ImageResources");

dojo.declare("itme.ChassisMap.ImageResources", null, {

  _defaultImagePath : "/images/hardwareView/hardware/",
  _ImageTable : {     // HARDWARE

    // CHASSIS
    ChassisFront: "re_chassis.png",
    ChassisBack: "re_backchassis.png",

    // BLADE SLOTS
    DefaultITE_1x: "itme1_194x43a.jpg",  // OLD
    DefaultITE_2x: "obj10.jpg",          // OLD
    FSM: "re_FSM.png", // IBM Flex System Manager
    ITE_C42x0M4: "re_blacktipITE.png", // blacktip: C4240 M4 , C4220 M4
    ITE_C42x0M4_PEN: "re_PEN.png", // blacktip: C4240 M4 , C4220 M4 w PEN
    ITE_C42x0M4_SEN: "re_SEN.png", // blacktip: C4240 M4 , C4220 M4 w SEN
    ITE_C4440M4: "re_congoITEfullwide.png", // C4440 M4
    ITE_C5440P7: "re_firebird4SITEfullwide.png", // firebird: C5440 P7
    ITE_C5240P7: "re_firebird2SITE.png", // firebird: C5240 P7
    EmptyBladeSlot: "re_blank.png",
    PME: "re_pmeITE.png",
    STRW_493949: "re_storwizeSRC.png",  //V7000 storage node SRC Controller model 4939-49
    STRW_493929: "re_storwizeSDE.png",  //V7000 storage node SDE Expansion model 4939-29

    // SWITCHES
    SwitchUnit: "SilverSwitch_26x343px.png",  // OLD
    SwitchEN2092: "SwitchEN2092.png",
    SwitchEN4091: "SwitchEN4091.png",
    SwitchEN4093: "SwitchEN4093.png",
    SwitchFC3171: "SwitchFC3171.png",
    SwitchFC5022: "SwitchFC5022.png",
    SwitchIB6131: "SwitchIB6131.png",
    SwitchFiller: "SwitchFiller.png",

    // POWER, FANS, CMMs & SPACERS
    PowerUnit: "re_powermodule.png",
    PowerUnitEmpty: "re_powermodulefiller.png",
    ITMEUnit: "CMM_b.png",
    CMM: "re_cmm.png",
    CMMFiller: "re_cmmfiller.png",
    FanUnit1: "re_largefan.png",
    FanUnit2: "re_smallfan.png",
    FanControlUnit: "re_fancontrolcard.png",
    FanControlFiller: "FanControlCardBlank_75x16px.png",
    FanFillerLarge: "re_largefanfiller.png",
    FanFillerSmall: "smallFanblank_75x36.png",
    TallSpacer: "re_chassisspacer.png",
    ShortSpacer: "SmallSpacer_b.png" // OLD
  },

  _basePath : "/images/",
  _defaultIconPath : "/images/hardwareView/",

  _IconTable : {
  // STATUS
    StatusFilterIcon_22: "status/statusCluster_22.png",
    StatusFilterIcon_32: "status/statusFilter_32.png",

    StatusCritical_16: "status/st16_critical_24.png",
    StatusCritical_22: "status/st22_critical_24.png",
    StatusCritical_34: "status/st34critical_shad.png",

    StatusWarningMinor_16: "status/ac16_WarningMinor_24.png",
    StatusWarningMinor_22: "status/ac22_WarningMinor_24.png",
    StatusWarningMinor_34: "status/st34minorwarning_shad.png",

    StatusInformational_16: "status/st16_informational_24.png",
    StatusInformational_22: "status/st22_info_24.png",
    StatusInformational_32: "status/st32_informational.png",
    StatusInformational_34: "status/st34informational_shad.png",

    StatusNormal_16: "status/st16_normalSTG_24.png",
    StatusNormal_22: "status/st22_normalSTG_24.png",
    StatusNormal_32: "status/st32_normalSTG_24.png",

  // ACCESS STATES
    //    ACCESS_STATE_NONE_ONLINE = 100;
    AccessOnlineNone_16: "access/st16_normalNoAccess_24.png",
    AccessOnlineNone_22: "access/st22_normalNoAcess_24.png",//"status_online_noAccess_obj.gif",
    // MISSING: AccessOnlineNone_32: "st32_normalNoAcess_24.png",

    //    ACCESS_STATE_NONE_OFFLINE = 101;
    AccessOfflineNone_16: "access/st16_offlineNoAccess_24.png",//"status_offline_noAccess_obj.gif",
    AccessOfflineNone_22: "access/st22_offlineNoAccess_24.png",
    // MISSING: AccessOfflineNone_32: "st32_offlineNoAccess_24.png",

    //    ACCESS_STATE_PARTIAL_ONLINE = 102;
    AccessOnlinePartial_SVG: "access/test.svg",//statusOnlinePartialAccess.svg",
    // MISSING: AccessOnlinePartial_16: "st16_normalPartialAccess_24.png",
    AccessOnlinePartial_22: "access/st22_normalPartialAccess_24.png",//"statusOnlinePartialAccess_obj22.png",
    // MISSING: AccessOnlinePartial_32: "st32_normalPartialAccess_24.png",

    //    ACCESS_STATE_PARTIAL_OFFLINE = 103;
    AccessOfflinePartial_16: "access/st16_offlinePartialAccess_24.png",
    AccessOfflinePartial_22: "access/st22_offlinePartialAccess_24.png",
    // MISSING: AccessOfflinePartial_32: "st32_offlinePartialAccess_24.png",

    //    ACCESS_STATE_FULL_ONLINE = 104;
    AccessOnlineOK_16: "access/st16_fullonlineaccess_24.png", // note path points to this._statusIconsPath.  Icon Re-Use
    AccessOnlineOK_22: "access/st22_fullonlineaccess_24.png",
    //AccessOnlineOK_32: "status/st16_normalSTG_24.png",

    //    ACCESS_STATE_FULL_OFFLINE = 105;
    //AccessOfflineOK_SVG: "Stopped_v1.svg",
    AccessOfflineOK_16: "access/st16_offline_24.png",
    AccessOfflineOK_22: "access/st22_offline_24.png",
    AccessOfflineOK_32: "access/st32_offline_24.png",

    //    ACCESS_STATE_UNKNOWN = 106;
    AccessUnknown_16: "access/st16_unknown_24.png",
    AccessUnknown_22: "access/st22_unknown_24.png",
    AccessUnknown_32: "access/st32_unknown_24.png",

    //    ACCESS_STATE_NOT_APPLICABLE = 107;
    AccessNotApplicable_16: "access/st16_undefined_24.png",
    AccessNotApplicable_22: "access/st22_undefined_24.png",
    AccessNotApplicable_32: "access/st32_undefined_24.png",

    //    ACCESS NOT TRUESTED = 109
    AccessNotTrusted_16: "access/st16_nottrustedcert_24.png",
    //AccessNotTrusted_22: "access/ .png",
    AccessNotTrusted_32: "access/st32_nottrustedcert_24.png",


  // LED
    LEDFilterIcon_22: "leds/LEDCluster.png",
    LEDPowerOn_16: "leds/ac16_power_24.png",
    LEDPowerOn_22: "leds/ac22_power_24.png",
    LEDPowerOff_16: "leds/ac16_powerOFF_24.png",
    LEDPowerOff_22: "leds/ac22_powerOFF_24.png",
    LEDErrorLogOn_16: "leds/ac16_errorLog_24.png",
    LEDErrorLogOn_22: "leds/ac22_errorLog_24.png",
    LEDErrorLogOff_16: "leds/ac16_errorLogOFF_24.png",
    LEDErrorLogOff_22: "leds/ac22_errorLogOFF_24.png",
    LEDLocationOn_16: "leds/ac16_location_24.png",
    LEDLocationOn_22: "leds/ac22_location_24.png",
    LEDLocationOff_16: "leds/ac16_locationOFF_24.png",
    LEDLocationOff_22: "leds/ac22_locationOFF_24.png",
    LEDFaultOn_16: "leds/ac16_enclosureFault_24.png",
    LEDFaultOn_22: "leds/ac22_enclosureFault_24.png",
    LEDFaultOff_16: "leds/ac16_enclosureFaultOFF_24.png",
    LEDFaultOff_22: "leds/ac22_enclosureFaultOFF_24.png",
    // DHM: Define the tray open LEDs
    // LEDTrayOpen_


  // LABELS
    LabelIcon_22: "ac22_tag_24.png",

  // THERMALS
    //ThermalIcon_22: "ac22_thermal_24.png",
    ThermalIcon_22: "Environment_22px.png",

  // REFRESH
    Processing_16: "processing.gif",
    RefreshIcon_16: "ac16_refresh.png",
    RefreshIcon_22: "ac22_refresh_24.png",

  // COMPLIANCE & OS
    ComplianceIcon_22: "ac22_compliance_24.png",

  // OTHER
    Seperator_18: "Separator.png"
  },

  getImage : function(ImageId) {
    //itmeUtils.CMTrace("MAIN", "getImage("+ImageId+"): " + contextPath + this._ImageTable[ImageId]);
    return contextPath + this._defaultImagePath + this._ImageTable[ImageId];
  },

  buildIconImageTag : function(IconId, styleClass, size) {
    var hasSVG = false;
    var imgTag = "";
    var iconPath = this._defaultIconPath;

    // special cases, they don't live in the chassis map icon path
    if ( ( IconId.indexOf("Processing") === 0 ) ||
         ( IconId.indexOf("Seperator") === 0 ) )
      iconPath = this._basePath;

    // find an icon of == or larger size
    for (var i = size; i < 40; i++) {
      if ( this._IconTable[IconId+"_"+i]) {
        imgTag = "<img src='"+contextPath+iconPath+this._IconTable[IconId+"_"+i]+"' width='"+parseInt(size)+"px' height='"+parseInt(size)+"px' class='"+styleClass+"'>";
        break;
      }
    }
    if (imgTag == "") // no images >= , then search <
    {
      for (i = size; i > 12; i--) {
        if ( this._IconTable[IconId+"_"+i]) {
          imgTag = "<img src='"+contextPath+iconPath+this._IconTable[IconId+"_"+i]+"' width='"+parseInt(size)+"px' height='"+parseInt(size)+"px' class='"+styleClass+"'>";
          break;
        }
      }
    }

    // if we have an SVG wrapper the img tag with it.  Browsers will render the Object tag first if it can
    if (false) {//this._IconTable[IconId+"_SVG"]) {
      imgTag = "<object type='image/svg+xml' data='"+contextPath+iconPath+this._IconTable[IconId+"_SVG"]+"' width='"+parseInt(size)+"' height='"+parseInt(size)+"' >" + imgTag + "</object>";
    }

    //itmeUtils.CMTrace("MAIN", "buildIconImageTag("+IconId+","+styleClass+","+size+"): " +imgTag);

    return imgTag;
  },

  // return the path to the icon id given.  If no _xx size is given in the id or 'size' parm doesn't match, largest match is returned
  iconPath: function(IconId, size) {
    var iconPath = this._defaultIconPath;

    // special cases, they don't live in the chassis map icon path
    if ( ( IconId.indexOf("Processing") === 0 ) ||
         ( IconId.indexOf("Seperator") === 0 ) )
      iconPath = this._basePath;

    if ( this._IconTable[IconId] )
      return contextPath + iconPath + this._IconTable[IconId];
    if ( size )
      if ( this._IconTable[IconId+"_"+size] )
        return contextPath + iconPath + this._IconTable[IconId+"_"+size];

    // iconID was no a direct match & size was not given or didn't match

    // then... find largest match
    for (var i = 40; i > 14; i-=2) {
      if ( this._IconTable[IconId+"_"+i]) {
        return contextPath + iconPath + this._IconTable[IconId+"_"+i];
      }
    }
    return "";
  }
});
