dojo.provide("itme.ChassisMap._Utils");


  // Scoped Utils =============================
dojo.declare("itme.ChassisMap._Utils", null, {

  constructor: function(kwArgs) {
  },

  // Something about director's consolecore.jar (json*.js) breaks dojo's tooltip.  This hack fixes it
  _unSetBadPrototypes: function() {
    
    // json*.js sets the below prototypes.  This breaks dojo's tooltip.  Deleting the prototype
    //   appears to fix the problem.  Note however that dynamic refresh won't work without these 
    //   defined prototypes.
    delete Object.prototype.toJSONString;
    //delete Array.prototype.toJSONString;
    //String.prototype.parseJSON = "";
  },
  
  // protected
  _findChassisNodeIndexFromItemsList: function(itemsList){
    for (var index = 0; index < itemsList.length; ++index) {
      if ( itemsList[index].getType() == "SystemChassis")
        return index;
    }
  },

  // protected
  _getProperty: function(item, propertyName){
    var propValue = null;
    try {
      var prop = item.getProperty(propertyName);
      if (prop) {
        propValue = prop.getValue();
      }
    } 
    catch (err) {
      itmeUtils.CMTrace("MAIN", "an error occurred getting properties for " + item.getLabel() + " : " + err);
    }
    return propValue;
  }

});
  