/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.charts.dijit.ChartPanelSummaryPage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.charts.dijit.ChartPanelSummaryPage"] = true;
dojo.provide("ibm.tivoli.tip.charts.dijit.ChartPanelSummaryPage");

dojo.require("ibm.tivoli.tip.charts.dijit.ChartPanelPage");
dojo.require("ibm.tivoli.widgetbuilder.widgetdefsummary.WidgetDefSummary");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartPanelSummaryPage",[ibm.tivoli.tip.charts.dijit.ChartPanelPage],{
	
		
	postCreate: function(){		
		this.inherited(arguments);	
		this.sumContainer.domNode.style.width = "40%";		
		this.summaryArea.domNode.style.height = "100%";
		this.sumPanel = new ibm.tivoli.widgetbuilder.widgetdefsummary.WidgetDefSummary({
			widgetDefinition: this.widgetDef
		},this.summaryDiv);		
	},	
	
	startup: function(){
		this.inherited(arguments);	
		this.sumPanel.domNode.style.overflow = "auto";
	},

	resize: function(size){		
		this.inherited(arguments);
		this.sumPanel.resize({w: size.w*0.4-20, h: size.h - 100});
	},
	
	setWidgetDefinition: function(widgetDef){
		this.inherited(arguments);
		if(this.widgetDef){
			this.sumPanel.setWidgetDefinition(this.widgetDef);		
		}
	},
	
	onChange: function(){		
		this.sumPanel.setWidgetDefinition(this.widgetDef);		
	},
	
	OnPageSelected: function(){
		this.inherited(arguments);
		if(this.widgetDef && this._isDatasetChange){
			this.sumPanel.setWidgetDefinition(this.widgetDef);	
		}
	}

});

}
