/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableDropDownButton"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableDropDownButton"] = true;
dojo.provide("ibm.tivoli.tip.dijit.TIPTableDropDownButton");

dojo.require("dijit.form.DropDownButton");


dojo.declare("ibm.tivoli.tip.dijit.TIPTableDropDownButton", [dijit.form.DropDownButton], {
	// summary:
	//		A button with a drop down
	//
	// example:
	// |	<button dojoType="dijit.form.DropDownButton" label="Hello world">
	// |		<div dojotype="dijit.Menu">...</div>
	// |	</button>
	//
	// example:
	// |	var button1 = new dijit.form.DropDownButton({ label: "hi", dropDown: new dijit.Menu(...) });
	// |	dojo.body().appendChild(button1);
	// 	
	
	baseClass : "dijitDropDownButton",

	templateString:"<span class=\"dijit dijitReset dijitLeft dijitInline\" dojoAttachEvent=\"onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse,onkeydown:_onDropDownKeydown,onblur:_onDropDownBlur,onkeypress:_onKey\">\n\t<span class=\"dijitReset dijitRight dijitInline\">\n\t\t<span class=\"dijitReset dijitInline dijitButtonNode quickFilterDownArrow\">\n\t\t\t<button class=\"dijitReset dijitStretch dijitButtonContents\" style=\"opacity:0;\" ${nameAttrSetting} type=\"${type}\" value=\"${value}\" dojoAttachPoint=\"focusNode,titleNode\" waiRole=\"button\" waiState=\"haspopup-true,labelledby-${id}_label\">\n\t\t\t\t<span class=\"dijitReset dijitInline\" dojoAttachPoint=\"iconNode\"></span>\n\t\t\t\t<span class=\"dijitReset dijitInline dijitButtonText\"  dojoAttachPoint=\"containerNode,popupStateNode\" id=\"${id}_label\"></span>\n\t\t\t\t<span class=\"dijitRest dijitInline\">&nbsp;&nbsp;&nbsp;</span>\n\t\t\t</button>\n\t\t</span>\n\t</span>\n</span>\n",
	
	//Added fix for IBM Dojo 1.5 Migration
	_onMouse: function(){	
	},	
	_onDropDownBlur: function(){	
	},	
	_onKey: function(){	
	},	
	_onDropDownKeydown: function(){	
	}
});

}
