/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.navwidget.iwidget.TableLocalWidgetDef"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.navwidget.iwidget.TableLocalWidgetDef"] = true;
dojo.provide("ibm.tivoli.tip.navwidget.iwidget.TableLocalWidgetDef"); 
 
dojo.require("ibm.tivoli.navmodel.TableWidgetDef");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.TableLocalWidgetDef",ibm.tivoli.navmodel.TableWidgetDef, {
	preamble: function(kwArgs){
		this._widgetDef=kwArgs.widgetDef;
		var defaultWidgetDefInfo= {
				baseUrl: "/ibm/tivoli/rest",
		    	provider: "any",
		    	datasource: "any",
		    	widget: "tables",
		    	definition: "DefaultItemsTable"
			};
		dojo.mixin(defaultWidgetDefInfo,kwArgs);//overwrite defaults with kwArgs
		dojo.mixin(kwArgs,defaultWidgetDefInfo);//add any defaults that kwArgs is missing
	},
	_fetchWidgetDef: function() {
		if(!this._widgetDef){
			this.inherited(arguments);
		}
	}
});

}
