/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["itme.finder.ResourceDataStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["itme.finder.ResourceDataStore"] = true;
dojo.provide("itme.finder.ResourceDataStore");

dojo.require("itme.finder.FinderBaseDataStore");

dojo.declare("itme.finder.ResourceDataStore", [itme.finder.FinderBaseDataStore], {
   constructor: function(type, domId){  	
    	this.populateItems(dojo.byId(domId + ':resourceFinderData').innerHTML);
    },
    populateItems: function() {
    	this.inherited(arguments);    
    },      
	
    
	initiateTaskSearch: function(searchString, finderObj) {	
		query = "name:'*" + searchString + "*' OR category:'*" + searchString + "*'";			
		itmeUtils.traceTimeDelta("finderTimer", "before initiating search", true); 
  		if(this._dataStore) {
  			var request = this._dataStore.fetch({
				query:{
					complexQuery: query
				}, queryOptions: {
					ignoreCase: true
				}, 
 				onError: dojo.hitch(finderObj, finderObj.fetchFailed), 
 				onComplete: dojo.hitch(finderObj, finderObj.doResourceSearch)
 			});	
  		} else {
  			finderObj.doResourceSearch(new Array(0), null);
  		}
			
	}
});
	

}
