dojo.provide("itme.finder.ContextTaskDataStore");
dojo.declare("itme.finder.ContextTaskDataStore", [itme.finder.FinderBaseDataStore], {
	
    constructor: function(type, list){  	
    	this.populateItems(list);
    },
    populateItems: function() {
    	this.inherited(arguments);    
    },    
   
	
    
	initiateTaskSearch: function(searchString, finderObj) {
		query = "name:'*" + searchString + "*' OR category:'*" + searchString + "*'";			
		itmeUtils.traceTimeDelta("finderTimer", "before initiating search", true); 
		if(this._dataStore) {
  			var request = this._dataStore.fetch({
				query:{
					complexQuery: query
				}, queryOptions: {
					ignoreCase: true
				}, 
 				onError: dojo.hitch(finderObj, finderObj.fetchFailed), 
 				onComplete: dojo.hitch(finderObj, finderObj.doContextTaskSearch)
 			});		
 		} else {
  			finderObj.doContextTaskSearch(new Array(0), null);
  		}
 		
	
	}
});
	