dojo.provide("itme.finder.TaskCategory");
dojo.declare("itme.finder.TaskCategory", null, {
	// private members       
  	_category: null,   
  	_ids: null,
  	_names: null,
  	_selectedIndexes: null,
  	_currentArrayIndex: 0,
  	_currentSelectedIndex: 0,
  	  
  	constructor: function(category){    
    	this._category = category;
    	this._ids = new Array(500);
    	this._names= new Array(500);
    	this._selectedIndexes= new Array(500);
  	},
  	add: function(id, name) {
  		this._ids[this._currentArrayIndex] = id;
  		this._names[this._currentArrayIndex] = name;
  		this._currentArrayIndex = this._currentArrayIndex + 1;  	
  		return this._currentArrayIndex - 1;	
  	},
  	getCategory: function() {
  		return this._category;
  	},
  	clearSelection: function() {
  		this._selectedIndexes = null;
  		this._currentSelectedIndex = 0;
  		this._selectedIndexes = new Array(500);
  	},
  	addSelected: function(index) {
  		this._selectedIndexes[this._currentSelectedIndex] = index;
  		this._currentSelectedIndex = this._currentSelectedIndex + 1; 
  	},
  	getSelectedCount: function() {
  		return this._currentSelectedIndex;
  	},
  	getSelectedName: function(index) {
  		return this._names[this._selectedIndexes[index]];
  	},
  	getSelectedId: function(index) {
  		return this._ids[this._selectedIndexes[index]];
  	},
  	getIds: function() {
  		return this._ids;
  	}
  	
});