// NLS_CHARSET=UTF-8
{
    //Placing finder strings here as well:
    Ellipsis: "...",
    FinderInitialText: "Find a Task or Hardware Resource",
    ContextFinderInitialText: "Find a Task for ",    
    ContextFinderTaskMenuFor: "Tasks for ", 
    NoMatchesFound: "(no matches found)",   
    Close: "Close dialog.",
    RefreshCache: "Refreshed {0} {1} ago. Refresh to include newly added/modified resources in results.",
    Minutes: "minute(s)",
    Hours: "hour(s)",
    Days: "day(s)",
    Searching0: "Searching.",
    Searching1: "Searching..",
    Searching2: "Searching...",
    MoreTasks: "Only the top results are displayed.  If your task is not displayed, refine your search terms or click here to use the task locator.",
    MoreResources: "Only the top results are displayed.  If your resource is not displayed, refine your search terms or click here to use the resource locator.",
    MoreGroups: "Only the top results are displayed.  If your group is not displayed, refine your search terms.",
    FinderTaskMenu: "Tasks",
    FinderResourceMenu: "Resources",
    FinderGroupMenu: "Groups",
    Chassis: "Chassis",
    Resources: "Resources",
    FinderTooltipHelp: "Use this inline finder to search for all tasks and managed resources.",
    ContextFinderTooltipHelp: "Use this inline finder to search in context for all tasks that can be launched against the current selection",

    // CHASSIS MAP
    LEDTitle: "LED Emphasis",
    StatusTitle: "Alerts",
    NameOverlayTitle: "Labels",
    ThermalTitle: "Thermals",
    
    Bay: "Bay",
    Loading: "Loading...",
    Model: "Model",
    MachineType: "Machine type",
    ModelMachineType: "Model and machine type",
    Name: "Name", 
    NameOverlayDetail: "Component Names & Properties",
    Refresh: "Page will refresh in ",
    Refreshing: "Refreshing",
    Seconds: " seconds",
    SerialNumber: "Serial number",
    Status: "Status",
    Problems: "Problems",
    StatusOverlayDetail: "Hardware Status",
    Type: "Type",
    ChassisMap: "Chassis Map",
    AccessOverlayDetail: "Hardware Access States",
    AccessTitle: "Access",
    AccessState: "Access State",
    Critical: "Critical",
    Warning: "Warning",
    Warnings: "Warnings",
    OperatingSystem: "Operating System",
    OK: "OK",
    Informational: "Informational",
    Normal: "Normal",
    NoAccessOffline: "No Access Offline",
    NoAccessOnline: "No Access Online",
    PartialAccessOffline: "Partial Access Offline",
    PartialAccessOnline: "Partial Access Online",
    OKAccessOffline: "Full Access Offline",
    OKAccessOnline: "Full Access Online",
    UnknownAccess: "Unknown",
    NAAccess: "Not Applicable",
    NotTrustedAccess: "Not Trusted",
    PowerLED: "Power LED",
    NoData: "No Data",
    AmbientTemp: "Ambient Temperature",
    ExhaustTemp: "Exhaust Temperature Index",
    Airflow: "Airflow",
    CFM: "CFM",
    PowerIn: "Input Power",
    //AuxInPowerAvg: "Average Power In",
    PowerOut: "Output Power",
    //AuxOutPowerAvg: "Average Power Out",
    TimeLastPolled: "Last Time Metered",
    EnvButtonTooltip: "Thermal and Power Metrics",
    PowerCap: "Power Cap",
    PowerCapShort: "(Cap)",
    Healthy: "Healthy",
    Errors: "Errors",
    NoCompliancePolicy: "No compliance policy",
    NoPolicy: "No policy",
    NotApplicable: "Not applicable",
    ComplianceStatus: "Compliance Status",
    NoOSDiscovered: "No OS discovered",
    NoOSDiscoveredUpdates: "The operating system for the compute node needs to be discovered to apply firmware updates",
    ProductHardware: "Flex System Hardware",
    SWProductName: "Flex System Manager",
    HARoleSubProp: " - High Availablitlity Role",
    MoreStatusEntries: "... there are {0} more status events.",
    GeneralActions: "General Actions",
    SubsystemDetails: "Subsystem Details",
    SwitchToTableView: "Switch To The Table View",
    FirmwareLevel: "Firmware Level",
    RefreshHWView: "Refresh the hardware view",
    Architecture: "Architecture",
    HWConnectionState: "Hardware Connection State",
    Discovering: "Discovering",
    Flashing: "Flashing",
    CommError: "Comm Error",
    Pending: "Pending...",
    HWNodeWarning: "A node is detected in this slot, but communications with the hardware cannot be established.",
    VPDNodeTooltipTitle: "Detected {0}",
    Fan: "Fan",
    Node: "Node",
    Switch: "Switch",
    PowerSupply: "Power Supply",
    BladeMgmtModule: "Blade Management Module",
    PassthroughModule: "Passthrough Module",
    FanLogicModule: "Fan Logic Module",
    StorageRaidController: "Storage Control Enclosure",
    StorageDiskExpansion: "Storage Expansion Enclosure",
    ClusterName: "Cluster Name",
    EnclosureId: "Enclosure Id",
    Error: "Error",
    FindActiveStatusOnChassis: "Click on the chassis to view active status details for this element.",
    Offline: "Offline",
    ComplianceOverlayTitle: "Compliance, Firmware & Notifications",
    // error messages
    ERROR_HWVIEW_NoData: "No data was returned.",
    ERROR_HWView_Title: "Hardware View Error",
    ERROR_HWView_InitialazitionFailed: "The hardware view failed to initialize, restarting your browser could resolve this issue.",
    ERROR_HWView_Unknown: "An unexpected error has occurred.",
    ERROR_HWView_DataRequestFailed: "The hardware view could not retrieve data from the server: ",
    ERROR_HWView_PropertyDataRequestFailed: "The hardware view could not retrieve an elements properties from the server: "
}

